﻿@using System.Web.UI.WebControls
@using System.Web.Mvc;
@using System.Data;

@using Portal.Models.AnnualPlan;

@model Toyota.Common.Web.MVC.ModelHolder
           
@Html.Common().DevExpress().GridView(
    gridView =>
    {
        gridView.Name = "APACDDDGridView";

        gridView.CallbackRouteValues = new { Controller = "AnnualPlan", Action = "PartialDetailAnnualPlanAPPSCrosstabDetailData" };
        gridView.ClientSideEvents.BeginCallback = "OnAPACDDDGridViewBeginCallback";
                    
        gridView.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
        gridView.Width = Unit.Percentage(100);

        gridView.Settings.ShowFilterRow = true;
        gridView.Settings.ShowFilterRowMenu = true;
        gridView.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
        gridView.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
        gridView.Settings.ShowColumnHeaders = true;

        gridView.SettingsPager.FirstPageButton.Visible = true;
        gridView.SettingsPager.LastPageButton.Visible = true;
        gridView.SettingsPager.ShowNumericButtons = true;
        gridView.SettingsPager.PageSizeItemSettings.Visible = true;
        gridView.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        gridView.SettingsPager.PageSizeItemSettings.Caption = "Page size";

        DateTime firstMonth = new DateTime();
        if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
        {
            firstMonth = new DateTime(Convert.ToInt32(DataBinder.Eval(Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList[0], "AP_YEAR")), 1, 1);
        }
        
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "AP_YEAR";
                column.Caption = "AP<br />Year";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 70;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "VERSION";
                column.Caption = "Version";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 70;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "PART_NO";
                column.Caption = "Part No";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 150;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "COLOR_SUFFIX";
                column.Caption = "Color<br/>Suffix";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 70;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "PART_NO_SFX";
                column.Caption = "Part No<br />Suffix";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 70;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "KANBAN_SIZE";
                column.Caption = "Kanban<br />Size";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 70;
            });       
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "SUPPLIER_CD";
                column.Caption = "Supplier<br />Code";
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.Width = Unit.Pixel(100);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "SUPPLIER_PLANT_CD";
                column.Caption = "Supplier<br />Plant";
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.Width = Unit.Pixel(100);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "SUPPLIER_NAME";
                column.Caption = "Supplier Name";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                column.Width = 250;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "PART_NAME";
                column.Caption = "Part Name";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                column.Width = 250;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "PART_MATCH_KEY";
                column.Caption = "Part<br />Matching Key";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = 100;
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "PLANT_CD";
                column.Caption = "Plant<br />Code";
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.Width = Unit.Pixel(60);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "CATEGORY_CD";
                column.Caption = "Category<br />Code";
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });

        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH1";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(0).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(0).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH2";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(1).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(1).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH3";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(2).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(2).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH4";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(3).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(3).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH5";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(4).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(4).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH6";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(5).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(5).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH7";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(6).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(6).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH8";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(7).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(7).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH9";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(8).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(8).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH10";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(9).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(9).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH11";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(10).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(10).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH12";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(11).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(11).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH13";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(12).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(12).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH14";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(13).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(13).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH15";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(14).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(14).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH16";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(15).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(15).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH17";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(16).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(16).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH18";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(17).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(17).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH19";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(18).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(18).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });

        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH20";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(19).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(19).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH21";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(20).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(20).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH22";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(21).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(21).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH23";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(22).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(22).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH24";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(23).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(23).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH25";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(24).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(24).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH26";
                
                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(25).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(25).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH27";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(26).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(26).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH28";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(27).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(27).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH29";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(28).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(28).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });

        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH30";
                
                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(29).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(29).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH31";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(30).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(30).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH32";
                
                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(31).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(31).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
           column =>
           {
               column.FieldName = "MONTH33";

               if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
               {
                   String year = Convert.ToString(firstMonth.AddMonths(32).Year).Substring(2);
                   String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(32).Month).Substring(0, 3);
                   column.Caption = month + "' " + year;
               }
               
               column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Width = Unit.Pixel(70);
           });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH34";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(33).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(33).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH35";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(34).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(34).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
        gridView.Columns.Add(
            column =>
            {
                column.FieldName = "MONTH36";

                if (Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList.Count > 0)
                {
                    String year = Convert.ToString(firstMonth.AddMonths(35).Year).Substring(2);
                    String month = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(firstMonth.AddMonths(35).Month).Substring(0, 3);
                    column.Caption = month + "' " + year;
                }
                
                column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Width = Unit.Pixel(70);
            });
    }).Bind(Model.GetModel<AnnualPlanAPPSModel>().AnnualPlanCrosstabDetailList).GetHtml()
